import * as fs from 'fs';
import * as path from 'path';
import confme from './confme';
import { ConfigType } from './confme';

const DIR_NAME: string = __dirname;

const dotEnvPath: string = path.join(DIR_NAME, '..', '.env');

const config: ConfigType = confme(
    path.join(DIR_NAME, './config.json'),
    path.join(DIR_NAME, './config-schema.json'),
    {
        path: fs.existsSync(dotEnvPath) && dotEnvPath,
        encoding: 'utf8',
        defaults: path.join(DIR_NAME, '..', '.env.defaults'),
    }
);

export default config;
