import * as mysql from 'mysql';
import config from './config';
import { Repository } from './lib/db/Repository';
import { createRepository } from './lib/db/createRepository';
import { createMariaDbConnection } from './lib/db/createrMariaDbConnection';
import ModelBase from './lib/models/ModelBase';
import Router from './lib/api/router';

const options: mysql.PoolConfig = {
    port: config.db.port,
    host: config.db.host,
    user: config.db.user,
    database: config.db.database,
    password: config.db.password,
};

const repository: Repository = createRepository({
    mariadb: createMariaDbConnection(options),
    shared: true,
});

ModelBase.setRepository(repository);

export default Router;
