import { SqsTypes } from '../../../common/constants';
import { makeRequestHandler } from '../utils';
import { AnchorRebootHandler, BatteryLevelHandler, SiteDisconnectedHandler, UnresponsiveNodeHandler } from '../../usecases';

export const main: { [key: string]: Function } = {
    [SqsTypes.ANCHOR_REBOOT]: makeRequestHandler(AnchorRebootHandler),
    [SqsTypes.BATTERY_LEVEL]: makeRequestHandler(BatteryLevelHandler),
    [SqsTypes.SITE_DISCONNECTED]: makeRequestHandler(SiteDisconnectedHandler),
    [SqsTypes.UNRESPONSIVE_NODE]: makeRequestHandler(UnresponsiveNodeHandler),
};
