import { SqsHandleEvents, } from '../models/interfaces';
import * as Controllers from './controllers';
import config from '../../config';

function parseMessage(messageString: string = '{}'): SqsHandleEvents {
    return JSON.parse(messageString);
}

export default async function(messageString: string): Promise<void> {
    if (!config.enable) {
        return;
    }
    const message: SqsHandleEvents = parseMessage(messageString);

    const controller: Function = Controllers.main[message.type];
    if (controller) {
        await controller(message);
    } else {
        config.log && console.error('No controller for message: ', messageString);
    }

    return undefined;
}
