import { LocationRepository, ProjectRepository, ServerRepository, SublocationRepository } from './documents';
import { CreateRepositoryOptions } from './createRepository';

export class Repository {
    /**
     * @typedef {any} Repository
     * @property location
     * @property project
     * @property server
     * @property sublocation
     */

    public location: LocationRepository = null;
    public project: ProjectRepository = null;
    public server: ServerRepository = null;
    public sublocation: SublocationRepository = null;

    /**
     * @param {Object} options - repository options
     * @param {Object} options.mariadb - mariadb connection
     */
    public constructor(options: CreateRepositoryOptions) {
        this.location = new LocationRepository(options);
        this.project = new ProjectRepository(options);
        this.server = new ServerRepository(options);
        this.sublocation = new SublocationRepository(options);
    }
}
