import RepoBase from '../RepoBase';
import { CreateRepositoryOptions } from '../createRepository';

export class LocationRepository extends RepoBase {
    /**
     * @typedef {Class} LocationRepository
     */

    public constructor(options: CreateRepositoryOptions) {
        super(options.mariadb);
    }

    /**
     * @method
     * @return {Promise<Array<Object>>} returns all nodes
     */
    public async readByUid(location_uid: string): Promise<any> {
        return this.mariadb.queryAsync('select * from locations where uid = ?;', [location_uid])
            .catch((err: any) => {
                console.error(err);
            });
    }
}
