import ModelBase from './ModelBase';

interface ILocation {
    name: string;
}

export class Location extends ModelBase {
    public async read(location_uid: string): Promise<ILocation[]> {
        return this.repository.location.readByUid(location_uid);
    }

    public async getLocationName(location_uid: string): Promise<string> {
        if (!location_uid) {
            return '';
        }
        const locations: ILocation[] = await this.read(location_uid);
        return locations.length === 1 ? locations[0].name : '';
    }
}
