import ModelBase from './ModelBase';

interface IProject {
    name: string;
}

export class Project extends ModelBase {
    public async read(project_uid: string): Promise<IProject[]> {
        return this.repository.project.readByUid(project_uid);
    }

    public async getProjectName(project_uid: string): Promise<string> {
        const projects: IProject[] = await this.read(project_uid);
        return projects.length === 1 ? projects[0].name : '';
    }
}
