import ModelBase from './ModelBase';

interface IServer {
    hostname: string;
}

export class Server extends ModelBase {
    public async read(server_uid: string): Promise<IServer[]> {
        return this.repository.server.readByUid(server_uid);
    }

    public async getServerName(server_uid: string): Promise<string> {
        const servers: IServer[] = await this.read(server_uid);
        return servers.length === 1 ? servers[0].hostname : '';
    }
}
