import ModelBase from './ModelBase';

interface ISublocation {
    name: string;
    location_uid: string;
}

export interface ISublocationResponse {
    sublocation_name: string;
    location_uid: string;
}

export class Sublocation extends ModelBase {
    public async read(sublocation_uid: string): Promise<ISublocation[]> {
        return this.repository.sublocation.readByUid(sublocation_uid);
    }

    public async getSublocationNameLocationUid(sublocation_uid: string): Promise<ISublocationResponse> {
        const sublocations: ISublocation[] = await this.read(sublocation_uid);
        return {
            sublocation_name: sublocations.length === 1 ? sublocations[0].name : '',
            location_uid: sublocations.length === 1 ? sublocations[0].location_uid : '',
        };
    }

}
