import { SqsClient } from '../models/client/sqsClient';
import { ISqsAnchorReboot, ISqsBatteryLevel, ISqsSiteDisconnected, ISqsUnresponsiveNodeEvent } from '../models/interfaces';

const sqsClient: SqsClient = new SqsClient();

export interface IExecuteResult {
    messageBody: ISqsUnresponsiveNodeEvent | ISqsSiteDisconnected | ISqsAnchorReboot | ISqsBatteryLevel;
    queues: string[];
}

export default class UseCaseBase {
    protected sqsClient: SqsClient;

    public constructor() {
        this.sqsClient = sqsClient;
    }

    public async run(params: any): Promise<IExecuteResult> {
        if (params) {
            return this.execute(params);
        }
    }
    protected async execute(params: any): Promise<IExecuteResult> {
        return null;
    }
}
